/*

"Test program for globalization"

Copyright (c) 2015 KINOSHITA Hidetoshi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--------------------------------------------------------------------------

"Test program for globalization"

Copyright (c) 2015 ؉pr

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\t
gEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐Ɉ
Ƃ𖳏ŋ܂Bɂ́A\tgEFA̕gpAʁAύXA
AfځAЕzATuCZXAс^܂͔̔錠Aу\tgEF
A񋟂鑊ɓƂ錠Ɋ܂܂܂B
 
L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
ɋLڂ̂Ƃ܂B 

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕
؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂
B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\
tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
ɂĐ؂̐AQȂ̋`ɂĉ̐ӔCȂ
̂Ƃ܂B

*/

#include "stdafx.h"
#include "MFC_Application.h"
#include "MFC_ApplicationDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMFC_ApplicationDlg dialog



CMFC_ApplicationDlg::CMFC_ApplicationDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMFC_ApplicationDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_ApplicationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RADIO1, m_radio_enUS);
	DDX_Control(pDX, IDC_RADIO2, m_radio_jaJP);
}

BEGIN_MESSAGE_MAP(CMFC_ApplicationDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO1, &CMFC_ApplicationDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CMFC_ApplicationDlg::OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_BUTTON1, &CMFC_ApplicationDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMFC_ApplicationDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CMFC_ApplicationDlg message handlers

BOOL CMFC_ApplicationDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_radio_enUS.SetCheck(true);
	setLang_EnUs();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFC_ApplicationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_ApplicationDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFC_ApplicationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CMFC_ApplicationDlg::OnBnClickedRadio1()
{
	setLang_EnUs();
}


void CMFC_ApplicationDlg::OnBnClickedRadio2()
{
	setLang_Jpn();
}


void CMFC_ApplicationDlg::setLang_Jpn()
{
	SetThreadLocale( MAKELCID(MAKELANGID(LANG_JAPANESE, SUBLANG_JAPANESE_JAPAN), SORT_DEFAULT) );
	SetThreadUILanguage( MAKELANGID(LANG_JAPANESE, SUBLANG_JAPANESE_JAPAN) );
	TRACE0("ja-JP.\n");
}

void CMFC_ApplicationDlg::setLang_EnUs()
{
	SetThreadLocale( MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT) );
	SetThreadUILanguage( MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US) );
	TRACE0("en-US.\n");
}


void CMFC_ApplicationDlg::OnBnClickedButton1()
{
	CAboutDlg dlg;

	dlg.DoModal();
}


void CMFC_ApplicationDlg::OnBnClickedButton2()
{
	CString message;
	CString caption;

	if (!message.LoadStringW(IDS_STR_01)){
		// \[X當擾łȂꍇ̏
		message = "[ERROR] There is no charactor string.";
	}
	if (!caption.LoadStringW(IDS_CAPTION_01)){
		// \[X當擾łȂꍇ̏
		caption = "[ERROR] There is no charactor string.";
	}

	MessageBox( message, caption);
}
